package com.cool.bang.common.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class DateUtil {

	public SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy-MM-dd HH:mm:ss");

	public Date getBeginTime(String beginTime) {
		beginTime += " 00:00:00";
		try {
			Date time = dateFormat.parse(beginTime);
			return time;
		} catch (Exception e) {
		}
		return null;
	}

	public Date getEndTime(String endTime) {
		endTime += " 23:59:59";
		try {
			Date time = dateFormat.parse(endTime);
			return time;
		} catch (Exception e) {
		}
		return null;
	}
	
	public String getConstellation(String birthday) {
		String star = "";
		Date birthdayDate = getBeginTime(birthday);
		Calendar calendar_birthday = Calendar.getInstance();
		calendar_birthday.setTime(birthdayDate);
		int month = calendar_birthday.get(Calendar.MONTH) + 1;
		int day = calendar_birthday.get(Calendar.DATE);
		if (month == 1 && day >= 20 || month == 2 && day <= 18) {
			star = "水瓶座";
		}
		if (month == 2 && day >= 19 || month == 3 && day <= 20) {
			star = "双鱼座";
		}
		if (month == 3 && day >= 21 || month == 4 && day <= 19) {
			star = "白羊座";
		}
		if (month == 4 && day >= 20 || month == 5 && day <= 20) {
			star = "金牛座";
		}
		if (month == 5 && day >= 21 || month == 6 && day <= 21) {
			star = "双子座";
		}
		if (month == 6 && day >= 22 || month == 7 && day <= 22) {
			star = "巨蟹座";
		}
		if (month == 7 && day >= 23 || month == 8 && day <= 22) {
			star = "狮子座";
		}
		if (month == 8 && day >= 23 || month == 9 && day <= 22) {
			star = "处女座";
		}
		if (month == 9 && day >= 23 || month == 10 && day <= 23) {
			star = "天秤座";
		}
		if (month == 10 && day >= 24 || month == 11 && day <= 22) {
			star = "天蝎座";
		}
		if (month == 11 && day >= 23 || month == 12 && day <= 21) {
			star = "射手座";
		}
		if (month == 12 && day >= 22 || month == 1 && day <= 19) {
			star = "摩羯座";
		}
		return star;
	}
	
	public int getAgeByBirthday(String birthday) {
		int age = 0;
		Date nowDate = new Date();
		Date birthdayDate = getBeginTime(birthday);

		Calendar calendar_birthday = Calendar.getInstance();
		calendar_birthday.setTime(birthdayDate);
		int birth_month = calendar_birthday.get(Calendar.MONTH) + 1;
		int birth_year = calendar_birthday.get(Calendar.YEAR);

		Calendar calendar_now = Calendar.getInstance();
		calendar_now.setTime(nowDate);
		int now_month = calendar_now.get(Calendar.MONTH) + 1;
		int now_year = calendar_now.get(Calendar.YEAR);
		age = now_year - birth_year;
		if (now_month >= birth_month) {
			age++;
		}
		return age;
	}

	public static String getCurDate(){
		SimpleDateFormat simple = new SimpleDateFormat("yyyy-MM-dd");
		return simple.format(new Date());
	}

	public static String getCurTime(){
		SimpleDateFormat simple = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		return simple.format(new Date());
	}

	/**
	 * 获取当前时间字符串
	 * @param format
	 * @return
	 */
	public static String getCurDateStr(String format){
		if( format == null ){
			return null;
		}
		SimpleDateFormat simple = new SimpleDateFormat(format);
		return simple.format(new Date());
	}

	/**
	 * 根据指定格式将日期转为字符串
	 * @param date
	 * @param format
	 * @return
	 */
	public static String dateToStr(Date date, String format){
		if( date == null || format == null ){
			return null;
		}
		SimpleDateFormat simple = new SimpleDateFormat(format);
		return simple.format(date);
	}

	/**
	 * 将指定格式的字符串转换为日期
	 * @param date
	 * @param format
	 * @return
	 */
	public static Date strToDate(String date,String format ){
		if( date == null || format == null ){
			return null;
		}
		DateFormat formater = new SimpleDateFormat(format);
		try {
			return formater.parse(date);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * 重新设置日期格式
	 * @param date
	 * @param format
	 * @return
	 */
	public static String formatStr(String date,String formatOld, String formatNew){
		Date d = strToDate(date,formatOld);
		return dateToStr(d,formatNew);
	}


	/**
	 * 获取当前年份
	 * @return
	 */
	public static int getCurYear(){
		int year = 1900;
		Calendar date = Calendar.getInstance();
		year = date.get(Calendar.YEAR);
		return year;
	}

	/**
	 * 获取上一年份
	 * @return
	 */
	public static int getBeforeYear(){
		int year = 1900;
		Calendar date = Calendar.getInstance();
		year = date.get(Calendar.YEAR)-1;
		return year;
	}
	/**
	 * 获取指定日期的年份
	 * @param date
	 * @return
	 */
	public static int getYearFromDate(Date date){
		int year = 1900;
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		year = calendar.get(Calendar.YEAR);
		return year;
	}

	/**
	 * 获取指定日期的年份
	 * @param date
	 * @param format
	 * @return
	 */
	public static int getYearFromDate(String date, String format){
		int year = 1900;

		DateFormat formater = new SimpleDateFormat(format);
		try {
			Date d = formater.parse(date);
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(d);
			year = calendar.get(Calendar.YEAR);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return year;
	}

	/**
	 * 获取当前月份
	 *  由1月份至12月份
	 * @return
	 */
	public static int getCurMonth(){
		int month = 1;
		Calendar date = Calendar.getInstance();
		month = date.get(Calendar.MONTH)+1;
		return month;
	}
	/**
	 * 获取上一月份
	 * @return
	 */
	public static int getBeforeMonth(){
		int month = 1;
		Calendar date = Calendar.getInstance();
		month = date.get(Calendar.MONTH);
		return month;
	}

	/**
	 * 补全月份
	 */
	public static String getCompleteMonth(int month){
		if(month <10){
			return "0"+String.valueOf(month);
		}else{
			return String.valueOf(month);
		}
	}

	public static String getBeforeMonth(String date,String format){
		Date cdate = strToDate(date, format);
		Calendar cd = Calendar.getInstance();
		cd.setTime(cdate);
		cd.add(Calendar.MONTH, -1);
		return dateToStr(cd.getTime(), format);

	}
	/**
	 * 获取指定日期的月份
	 *  由1月份至12月份
	 * @param date
	 * @return
	 */
	public static int getMonthFromDate(Date date){
		int month = 1;
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		month = calendar.get(Calendar.MONTH)+1;
		return month;
	}

	/**
	 * 获取指定日期的月份
	 *  由1月份至12月份
	 * @param date
	 * @return
	 */
	public static int getMonthFromDate(String date, String format){
		int month = 1;

		DateFormat formater = new SimpleDateFormat(format);
		try {
			Date d = formater.parse(date);
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(d);
			month = calendar.get(Calendar.MONTH)+1;
		} catch (Exception e) {
			e.printStackTrace();
		}

		return month;
	}

	/**
	 * 获取当前日号
	 *  由1号开始
	 * @return
	 */
	public static int getCurDay(){
		int day = 1;
		Calendar date = Calendar.getInstance();
		day = date.get(Calendar.DATE);
		return day;
	}

	/**
	 * 获取指定日期的日号
	 *  由1号开始
	 * @param date
	 * @return
	 */
	public static int getDayFromDate(Date date){
		int day = 1;
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		day = calendar.get(Calendar.DATE);
		return day;
	}

	/**
	 * 获取指定日期的日号
	 * @param date
	 * @param format
	 * @return
	 */
	public static int getDayFromDate(String date, String format){
		int day = 1;

		DateFormat formater = new SimpleDateFormat(format);
		try {
			Date d = formater.parse(date);
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(d);
			day = calendar.get(Calendar.DATE);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return day;
	}

	/**
	 * 获取当前日期的星期
	 *  星期天返回0, 星期一至星期六 返回1-6
	 * @return
	 */
	public static int getCurWeek(){
		return Calendar.getInstance().get(Calendar.DAY_OF_WEEK)-1;
	}

	/**
	 * 获取指定日期的星期
	 * @param date
	 * @return
	 */
	public static int getWeekFromDate(Date date){
		int week = 0;
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		week = calendar.get(Calendar.DAY_OF_WEEK)-1;
		return week;
	}

	/**
	 * 获取指定日期的星期
	 * @param date
	 * @param format
	 * @return
	 */
	public static int getWeekFromDate(String date, String format){
		int week = 0;
		DateFormat formater = new SimpleDateFormat(format);
		try {
			Date d = formater.parse(date);
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(d);
			week = calendar.get(Calendar.DAY_OF_WEEK)-1;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return week;
	}

	public static String weekString(int week){
		switch(week){
			case 0:return "星期天";
			case 1:return "星期一";
			case 2:return "星期二";
			case 3:return "星期三";
			case 4:return "星期四";
			case 5:return "星期五";
			case 6:return "星期六";
			default:return "";
		}
	}
	/**
	 * 得到一天的开始时间
	 * 	如 2012-04-12 17:23:01 返回 2012-04-12 00:00:00
	 * @param currentDate
	 * @return
	 */
	public static Date getStartDate(Date currentDate) {
		final Calendar minCalendar = Calendar.getInstance();
		minCalendar.setTime(currentDate);
		minCalendar.set(Calendar.HOUR_OF_DAY, 0);
		minCalendar.set(Calendar.MINUTE, 0);
		minCalendar.set(Calendar.SECOND, 0);
		minCalendar.set(Calendar.MILLISECOND, 0);
		return minCalendar.getTime();
	}
	/**
	 * 得到一天的截止时间
	 *  如 2012-04-12 17:23:01 返回 2012-04-12 59:59:59
	 * @param currentDate
	 * @return
	 */
	public static Date getEndDate(Date currentDate) {
		final Calendar cal = Calendar.getInstance();
		cal.setTime(currentDate);
		cal.set(Calendar.HOUR_OF_DAY, 23);
		cal.set(Calendar.MINUTE, 59);
		cal.set(Calendar.SECOND, 59);
		cal.set(Calendar.MILLISECOND, 999);
		return cal.getTime();
	}
	/**
	 * 得到本月最后一天
	 * @param date
	 * @return
	 */
	public static Date lastDayOfMonth(Date date) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.add(Calendar.MONTH, 1);
		cal.add(Calendar.DATE, -1);
		return cal.getTime();
	}

	/**
	 * 得到下一天
	 *  如 2012-04-12 17:23:01 返回 2012-04-13 17:23:01
	 * @param cdate
	 * @return
	 */
	public static Date nextDate(Date cdate) {
		Date date = null;

		Calendar cd = Calendar.getInstance();
		cd.setTime(cdate);
		cd.add(Calendar.DATE, 1);
		date = cd.getTime();

		return date;
	}

	public static Date nextDate(Date cdate,int days) {
		Date date = null;

		Calendar cd = Calendar.getInstance();
		cd.setTime(cdate);
		cd.add(Calendar.DATE, days);
		date = cd.getTime();

		return date;
	}

	/**
	 * 得到下一天
	 * @param cdate
	 * @param format
	 * @return
	 */
	public static Date nextDate(String cdate,String format) {
		Date date = null;

		SimpleDateFormat sdf = new SimpleDateFormat(format);
		Calendar cd = Calendar.getInstance();
		try {
			cd.setTime(sdf.parse(cdate));
		} catch (ParseException e) {
			e.printStackTrace();
		}
		cd.add(Calendar.DATE, 1);
		date = cd.getTime();

		return date;
	}

	public static Date beforeDate(String format){
		Date date = null;

		SimpleDateFormat sdf = new SimpleDateFormat(format);
		Calendar cd = Calendar.getInstance();
		try {
			cd.setTime(sdf.parse(getCurDateStr(format)));
		} catch (ParseException e) {
			e.printStackTrace();
		}
		cd.add(Calendar.DATE, -1);
		date = cd.getTime();

		return date;
	}
	/**
	 * 得到下一个时间点
	 * @param date 当前时间
	 * @param nextType 1天   2月  3年   4小时  5分钟
	 * @param amount 变更的数量
	 * @return
	 */
	public static Date nextDate(Date cDate,int nextType,int amount){
		Date date = null;

		Calendar cd = Calendar.getInstance();
		cd.setTime(cDate);

		if( nextType == 1 )
			cd.add(Calendar.DATE, amount);		//天
		else if( nextType == 2 )
			cd.add(Calendar.MONTH, amount); 	//月
		else if( nextType == 3 )
			cd.add(Calendar.YEAR, amount);		//年
		else if( nextType == 4 )
			cd.add(Calendar.HOUR, amount);		//小时
		else if( nextType == 5 )
			cd.add(Calendar.MINUTE, amount);	//分钟

		date = cd.getTime();

		return date;
	}

	/**
	 * 得到下一个日期
	 *  日期格式（yyyy-MM-dd）
	 * @param cDate	当前日期 yyyy-MM-dd
	 * @param nextType  1天   2月  3年
	 * @param amount 变更的数量
	 * @return 返回下一个日期 yyyy-MM-dd
	 */
	public static String nextDate(String cDate,int nextType,int amount){
		String next = null;

		String format = "yyyy-MM-dd";
		DateFormat formater = new SimpleDateFormat(format);
		try {
			Date date = formater.parse(cDate);
			next = nextDate(date, format, nextType, amount);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return next;
	}

	/**
	 * 得到下一个时间点
	 * @param cDate 当前时间
	 * @param format 时间格式（按本格式返回时间点）
	 * @param nextType 1天   2月  3年   4小时  5分钟
	 * @param amount 变更的数量
	 * @return
	 */
	public static String nextDate(String cDate, String format, int nextType, int amount){
		DateFormat formater = new SimpleDateFormat(format);
		Date date = null;
		try {
			date = formater.parse(cDate);
			date = nextDate(date, nextType, amount);
		} catch (ParseException e) {
			e.printStackTrace();
		}

		return formater.format(date);
	}

	/**
	 * 得到下一个时间点
	 * @param cDate cDate 当前时间
	 * @param format 返回时间格式
	 * @param nextType 1天   2月  3年   4小时  5分钟
	 * @param amount 变更的数量
	 * @return
	 */
	public static String nextDate(Date cDate, String format, int nextType, int amount){
		DateFormat formater = new SimpleDateFormat(format);
		Date date = nextDate(cDate, nextType, amount);

		return formater.format(date);
	}


	/**
	 * 比较日期前后
	 *  如果date1在date2之前 返回1，date1==date2 返回0，date1在date2之后 返回-1
	 * @param
	 * @return
	 */
	public static int compareDate(Date date1, Date date2) {
		if (date1.after(date2)) {
			return -1;
		} else if (date1.before(date2)) {
			return  1;
		} else {
			return 0;
		}
	}

	public static int compareDate(String date1, String date2) {
		Date d1 = strToDate(date1, "yyyy-MM-dd");
		Date d2 = strToDate(date2, "yyyy-MM-dd");
		if (d1.after(d2)) {
			return -1;
		} else if (d1.before(d2)) {
			return  1;
		} else {
			return 0;
		}
	}

	/**
	 * 是否同一天
	 * 	不考虑时间  仅判断日期
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static boolean isEqualsDate(Date d1, Date d2) {
		String sd1 = new SimpleDateFormat("yyyy-MM-dd").format(d1);
		String sd2 = new SimpleDateFormat("yyyy-MM-dd").format(d2);
		if (sd1.equals(sd2)) {
			return true;
		} else {
			return false;
		}
	}

	public static String getDateStr(int year, int month){
		StringBuffer sDate = new StringBuffer();
		sDate.append(year);
		sDate.append("-");
		if( month > 9 ){
			sDate.append(month);
		}else {
			sDate.append("0").append(month);
		}

		return sDate.toString();
	}

	public static String getDateStr(int year, int month, int day){
		StringBuffer sDate = new StringBuffer();
		sDate.append(year);
		sDate.append("-");
		if( month > 9 ){
			sDate.append(month);
		}else {
			sDate.append("0").append(month);
		}
		sDate.append("-");
		if( day > 9 ){
			sDate.append(day);
		}else {
			sDate.append("0").append(day);
		}

		return sDate.toString();
	}

	/**
	 * 获取指定年月总天数
	 * @return
	 */
	public static int getMonthDays(int year, int month){
		int[] mds = {31,28,31,30,31,30,31,31,30,31,30,31};

		int days = 0;	//
		if( month == 2 ){
			if( year %400 == 0 || (year%100 !=0 && year%4 == 0 )){
				days = 29;
			}else {
				days = 28;
			}
		} else {
			days = mds[month-1];
		}
		return days;
	}
	/**
	 * 获取当前时间所在周的所有日期或部分日期
	 * @param format格式化 例如yyyy年MM月dd日 E
	 * @param num 返回日期个数,从本周第一天开始
	 * @return List<String>
	 */
	public static List<String> getWeekdays(String format, int num) {
		List<String> list = new ArrayList<String>();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		Calendar calendar = Calendar.getInstance();
		getMonCalender(calendar);
		for (int i = 0; i < num; i++) {
			list.add(sdf.format(calendar.getTime()));
			calendar.add(Calendar.DATE, 1);
		}
		return list;
	}
	private static Calendar getMonCalender(Calendar calendar) {
		while (true) {
			if (calendar.get(Calendar.DAY_OF_WEEK) != Calendar.MONDAY) {
				calendar.add(Calendar.DATE, -1);
				continue;
			}else {
				return calendar;
			}
		}
	}
	/**
	 * 当前日期是本月的第几周
	 * @return
	 */
	public static int getWeekNoOfMonth() {
		Calendar c=Calendar.getInstance();
		c.setFirstDayOfWeek(Calendar.MONDAY);//设置星期一为一周的第一天。默认星期日是一周的第一天.
		int i = c.get(Calendar.WEEK_OF_MONTH);
		return i;

	}
	// 获得当前日期与本周日相差的天数
	private static int getMondayPlus() {
		Date gmtCreate = new Date();
		Calendar cd = Calendar.getInstance();
		cd.setTime(gmtCreate);
		// 获得今天是一周的第几天，星期日是第一天，星期一是第二天......
		int dayOfWeek = cd.get(Calendar.DAY_OF_WEEK) - 1; // 因为按中国礼拜一作为第一天所以这里减1
		System.out.println(dayOfWeek);
		if (dayOfWeek == 1) {
			return 0;
		} else {
			return 1 - dayOfWeek;
		}
	}

	// 获得下周星期一的日期
	public static String getNextMonday() {
		int mondayPlus = getMondayPlus();
		GregorianCalendar currentDate = new GregorianCalendar();
		currentDate.add(GregorianCalendar.DATE, mondayPlus + 7);
		Date monday = currentDate.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//	    System.out.println(sdf.format(monday));
		return sdf.format(monday);
	}
	public static String getNextFriday() {
		int mondayPlus = getMondayPlus();
		GregorianCalendar currentDate = new GregorianCalendar();
		currentDate.add(GregorianCalendar.DATE, mondayPlus + 11);
		Date friday = currentDate.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//		    System.out.println(sdf.format(friday));
		return sdf.format(friday);
	}

	/**
	 * 返回给定区间的所有日期,包含起止日期
	 * @param dBegin 格式 yyyy-MM-dd
	 * @param dEnd 格式 yyyy-MM-dd
	 * @return list<String>
	 * @throws ParseException
	 */
	public static List<String> findDates(String dBegin, String dEnd) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date BeginD = sdf.parse(dBegin);
		Date EndD = sdf.parse(dEnd);

		List<String> lDate = new ArrayList<String>();
		lDate.add(dBegin);
		Calendar calBegin = Calendar.getInstance();
		calBegin.setTime(BeginD);
		Calendar calEnd = Calendar.getInstance();
		calEnd.setTime(EndD);
		while (EndD.after(calBegin.getTime())) {
			calBegin.add(Calendar.DAY_OF_MONTH, 1);
			lDate.add(sdf.format(calBegin.getTime()));
		}
		//       System.out.println(lDate);
		return lDate;
	}
	//根据日期取得星期几
	public static String getDayofWeekNo(String wdate) throws ParseException{
		String[] weeks = {"周日","周一","周二","周三","周四","周五","周六"};
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date date = sdf.parse(wdate);
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		int week_index = cal.get(Calendar.DAY_OF_WEEK) - 1;
		if(week_index<0){
			week_index = 0;
		}
//        System.out.println(weeks[week_index]);
		return weeks[week_index];
	}
	/**
	 * 得到本周周一
	 *
	 * @return yyyy-MM-dd
	 */
	public static String getMondayOfThisWeek() {
		SimpleDateFormat df2 = new SimpleDateFormat("yyyy-MM-dd");
		Calendar c = Calendar.getInstance();
		int day_of_week = c.get(Calendar.DAY_OF_WEEK) - 1;
		if (day_of_week == 0)
			day_of_week = 7;
		c.add(Calendar.DATE, -day_of_week + 1);
		System.out.println(df2.format(c.getTime()));
		return df2.format(c.getTime());

	}

	/**
	 * 得到本周周日
	 *
	 * @return yyyy-MM-dd
	 */
	public static String getFridayOfThisWeek() {
		SimpleDateFormat df2 = new SimpleDateFormat("yyyy-MM-dd");
		Calendar c = Calendar.getInstance();
		int day_of_week = c.get(Calendar.DAY_OF_WEEK) - 1;
		if (day_of_week == 0)
			day_of_week = 7;
		c.add(Calendar.DATE, -day_of_week + 5);
		System.out.println(df2.format(c.getTime()));
		return df2.format(c.getTime());
	}

	/**
	 * 查询另个日期之间间隔天数
	 * @param smdate
	 * @param bdate
	 * @param format
	 * @return
	 */
	public static int daysBetween(String smdate,String bdate, String format) {
		long between_days = -1;

		try {
			SimpleDateFormat sdf=new SimpleDateFormat(format);
			Calendar cal = Calendar.getInstance();
			cal.setTime(sdf.parse(smdate));
			long time1 = cal.getTimeInMillis();
			cal.setTime(sdf.parse(bdate));
			long time2 = cal.getTimeInMillis();
			between_days=(time2-time1)/(1000*3600*24);
		} catch (ParseException e) {
			e.printStackTrace();
		}

		return Integer.parseInt(String.valueOf(between_days));
	}

	/**
	 * 查询两个时间之间的间隔
	 * @return
	 */
	public static int datesBetween(Date smdate, Date bdate){
		long between_days = -1;

		Calendar cal = Calendar.getInstance();
		cal.setTime(smdate);
		long time1 = cal.getTimeInMillis();
		cal.setTime(bdate);
		long time2 = cal.getTimeInMillis();
		between_days=(time2-time1)/(1000*3600*24);

		return Integer.parseInt(String.valueOf(between_days));
	}

	/**
	 * 时间转大写
	 * 2021-07-04 转为 二〇二一年七月四日
	 * @return
	 */
	public static String dateToUpper(Date date){
		Calendar ca = Calendar.getInstance();
		ca.setTime(date);
		String year = numToUpper(ca.get(Calendar.YEAR));
		String month = monthToUppder(ca.get(Calendar.MONTH) + 1);
		String day = dayToUppder(ca.get(Calendar.DAY_OF_MONTH));

		return year + "年" + month + "月" + day + "日";
	}

	// 将数字转化为大写（字体格式可自己定义）
	public static String numToUpper(int num) {
		String u[] = {"〇","一","二","三","四","五","六","七","八","九"};
		char[] str = String.valueOf(num).toCharArray();
		String rstr = "";
		for (int i = 0; i < str.length; i++) {
			rstr = rstr + u[Integer.parseInt(str[i] + "")];
		}
		return rstr;
	}

	// 月转化为大写
	public static String monthToUppder(int month) {
		if(month < 10) {
			return numToUpper(month);
		} else if(month == 10){
			return "十";
		} else {
			return "十" + numToUpper(month - 10);
		}
	}

	// 日转化为大写
	public static String dayToUppder(int day) {
		if(day < 20) {
			return monthToUppder(day);
		} else {
			char[] str = String.valueOf(day).toCharArray();
			if(str[1] == '0') {
				return numToUpper(Integer.parseInt(str[0] + "")) + "十";
			}else {
				return numToUpper(Integer.parseInt(str[0] + "")) + "十" + numToUpper(Integer.parseInt(str[1] + ""));
			}
		}
	}

	/**
	 * 获取指定日期的年，月，日（数字）
	 * type 1年 2月 3日
	 * @param date
	 * @param type
	 * @return
	 */
	public static int dateToNum(Date date,int type){
		int num = 0;
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		if (type == 1){
			num = calendar.get(Calendar.YEAR);
		}else if (type == 2){
			num = calendar.get(Calendar.MONTH)+1;
		}else if (type == 3){
			num = calendar.get(Calendar.DATE);
		}
		return num;
	}

}
