package com.cool.bang.modules.mysql.domain;

import com.cool.bang.modules.oracle.domain.OracleAppropriationDetail;
import com.cool.bang.modules.oracle.domain.po.Bfmx;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 拨付申请明细
 */
public class AppropriationDetail {

    private static final long serialVersionUID = 1L;

    private Long id;

    /** 拨付表主键 */
    private Long appropriationId;

    /** 楼幢户主键 */
    private Long buildingAccountId;

    /** 楼幢编号 */
    private String buildingNumber;

    /** 楼幢名称 */
    private String buildingName;

    /** 监管余额 */
    private BigDecimal accountBalance;

    /** 留存比例 */
    private BigDecimal keepPercentage;

    /** 留存金额 */
    private BigDecimal keepAmount;

    /** 拨付金额 */
    private BigDecimal applyAmount;

    /** 删除标识 1正常 0删除 */
    private Integer delFlag;

    private Date createTime;
    private Date updateTime;

    public AppropriationDetail(){}

    public AppropriationDetail(OracleAppropriationDetail oracleAppropriationDetail) {
        this.buildingNumber = oracleAppropriationDetail.getBuildingNumber();
        this.buildingName = oracleAppropriationDetail.getBuildingName();
        this.accountBalance = oracleAppropriationDetail.getAccountBalance();
        this.keepPercentage = oracleAppropriationDetail.getKeepPercentage();
        this.keepAmount = oracleAppropriationDetail.getKeepAmount();
        this.applyAmount = oracleAppropriationDetail.getApplyAmount();
        this.delFlag = 1;
    }

    public AppropriationDetail(Bfmx bfmx,Appropriation appropriation,BuildingAccount buildingAccount){
        this.appropriationId = appropriation.getId();
        this.buildingAccountId = buildingAccount.getId();
        this.buildingNumber = buildingAccount.getBuildingNumber();
        this.buildingName = buildingAccount.getBuildingName();
        this.accountBalance = bfmx.getLzye();
        this.keepPercentage = bfmx.getLcbl();
        this.keepAmount = bfmx.getLcje();
        this.applyAmount = bfmx.getLzsqzj();
        this.delFlag = 1;
        this.createTime = appropriation.getCreateTime();
        this.updateTime = appropriation.getUpdateTime();
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getAppropriationId() {
        return appropriationId;
    }

    public void setAppropriationId(Long appropriationId) {
        this.appropriationId = appropriationId;
    }

    public Long getBuildingAccountId() {
        return buildingAccountId;
    }

    public void setBuildingAccountId(Long buildingAccountId) {
        this.buildingAccountId = buildingAccountId;
    }

    public String getBuildingNumber() {
        return buildingNumber;
    }

    public void setBuildingNumber(String buildingNumber) {
        this.buildingNumber = buildingNumber;
    }

    public String getBuildingName() {
        return buildingName;
    }

    public void setBuildingName(String buildingName) {
        this.buildingName = buildingName;
    }

    public BigDecimal getAccountBalance() {
        return accountBalance;
    }

    public void setAccountBalance(BigDecimal accountBalance) {
        this.accountBalance = accountBalance;
    }

    public BigDecimal getKeepPercentage() {
        return keepPercentage;
    }

    public void setKeepPercentage(BigDecimal keepPercentage) {
        this.keepPercentage = keepPercentage;
    }

    public BigDecimal getKeepAmount() {
        return keepAmount;
    }

    public void setKeepAmount(BigDecimal keepAmount) {
        this.keepAmount = keepAmount;
    }

    public BigDecimal getApplyAmount() {
        return applyAmount;
    }

    public void setApplyAmount(BigDecimal applyAmount) {
        this.applyAmount = applyAmount;
    }

    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }
}



