package com.cool.bang.modules.mysql.domain;

import com.cool.bang.modules.mysql.domain.flowPo.ApprovalRecord;
import com.cool.bang.modules.oracle.domain.AregItem;
import com.cool.bang.modules.oracle.domain.OracleRelieve;
import com.cool.bang.modules.oracle.domain.po.Jgxmjc;
import com.sun.istack.internal.NotNull;

import java.util.Date;
import java.util.List;

/**
 * 解除申请
 *
 * @author PeiZhi Guo
 * 2022-09-26 09:30
 */
public class Relieve {

    private static final long serialVersionUID = 1L;

    private Long id;

    /** 业务编号 */
    private String businessNumber;

    /** 企业主键 */
    private Integer orgId;

    /** 企业名称 */
    private String orgName;

    /** 项目主键 */
    private Long projectId;

    /** 项目编码 */
    private String projectNumber;

    /** 项目名称 */
    private String projectName;

    /** 联系人*/
    private String director;

    /** 联系电话*/
    private String phone;

    /** 流程号 */
    private String flowNumber;

    /** 下一个流程节点 */
    private Long flowNodeId;

    /** 流程节点名称 */
    private String flowNodeName;

    /** 解除类型 1项目解除 2楼幢解除 */
    private Integer relieveType;

    /** 解除楼幢 */
    private String relieveBuilding;

    /** 业务类型 1托管 2监管 */
    private Integer businessType;

    /** 业务状态 1发起申请 2正在审核 3申请成功 4申请退回 */
    private Integer businessState;

    /** 删除标识 1正常 0删除 */
    private Integer delFlag;

    private Date createTime;
    private Date updateTime;
    private String remark;


    private String lzbh;

    public Relieve(){}

    public Relieve(OracleRelieve relieve) {
        this.businessNumber = relieve.getBusinessNumber();
        this.director = relieve.getDirector();
        this.phone = relieve.getPhone();
        this.businessType = relieve.getAccountType() == 1 ? 1 : 2;
        this.createTime = relieve.getCreateTime();
        this.updateTime = relieve.getUpdateTime();
        this.delFlag = 1;

    }

    public Relieve(Jgxmjc jgxmjc,Org org,Project project){
        this.businessNumber = jgxmjc.getYwbh();
        //this.orgId = Long.valueOf(org.getId());
        this.orgName = org.getOrgName();
        this.projectId = project.getId();
        this.projectNumber = project.getProjectNumber();
        this.projectName = project.getProjectName();
        this.director = jgxmjc.getLxr();
        this.phone = jgxmjc.getLxdh();
        this.businessType = jgxmjc.getJglx() == 0 ? 1 : 2;
        this.businessState = 3;
        this.delFlag = 1;
        this.createTime = jgxmjc.getSqrq();
        this.updateTime = jgxmjc.getShrq();
        String relieveBuilding = "";
        if (jgxmjc.getAregItemList() != null && jgxmjc.getAregItemList().size() > 0){
            for (AregItem aregItem : jgxmjc.getAregItemList()) {
                relieveBuilding = relieveBuilding + aregItem.getLzmc() + ",";
            }
        }
        this.relieveBuilding = relieveBuilding;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getBusinessNumber() {
        return businessNumber;
    }

    public void setBusinessNumber(String businessNumber) {
        this.businessNumber = businessNumber;
    }

    public Integer getOrgId() {
        return orgId;
    }

    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public String getProjectNumber() {
        return projectNumber;
    }

    public void setProjectNumber(String projectNumber) {
        this.projectNumber = projectNumber;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getDirector() {
        return director;
    }

    public void setDirector(String director) {
        this.director = director;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getFlowNumber() {
        return flowNumber;
    }

    public void setFlowNumber(String flowNumber) {
        this.flowNumber = flowNumber;
    }

    public Long getFlowNodeId() {
        return flowNodeId;
    }

    public void setFlowNodeId(Long flowNodeId) {
        this.flowNodeId = flowNodeId;
    }

    public String getFlowNodeName() {
        return flowNodeName;
    }

    public void setFlowNodeName(String flowNodeName) {
        this.flowNodeName = flowNodeName;
    }

    public Integer getRelieveType() {
        return relieveType;
    }

    public void setRelieveType(Integer relieveType) {
        this.relieveType = relieveType;
    }

    public String getRelieveBuilding() {
        return relieveBuilding;
    }

    public void setRelieveBuilding(String relieveBuilding) {
        this.relieveBuilding = relieveBuilding;
    }

    public Integer getBusinessType() {
        return businessType;
    }

    public void setBusinessType(Integer businessType) {
        this.businessType = businessType;
    }

    public Integer getBusinessState() {
        return businessState;
    }

    public void setBusinessState(Integer businessState) {
        this.businessState = businessState;
    }

    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }


    public String getLzbh() {
        return lzbh;
    }

    public void setLzbh(String lzbh) {
        this.lzbh = lzbh;
    }
}
