package com.cool.bang.modules.mysql.domain;

import com.cool.bang.common.util.DateUtil;
import com.cool.bang.modules.oracle.domain.po.Jgyw;

import java.util.Date;

/**
 * 监管申请
 *
 * @author PeiZhi Guo
 * 2022-09-16 15:45
 */
public class SuperviseBusiness {

    private static final long serialVersionUID = 1L;

    private Long id;

    /** 业务编号 */
    private String businessNumber;

    /** 银行编码 */
    private String bankCode;

    /** 企业ID */
    private Integer orgId;

    /** 企业名称 */
    private String orgName;

    /** 项目主键 */
    private Long projectId;

    /** 项目编号 */
    private String projectNumber;

    /** 项目名称 */
    private String projectName;

    /** 项目地址 */
    private String projectAddress;

    /** 账户ID */
    private Long accountId;

    /** 监管银行 */
    private String bankName;

    /** 监管账户 */
    private String name;

    /** 监管账号 */
    private String account;

    /** 开户网点 */
    private String accountOpenAddress;

    /** 联系人 */
    private String operator;

    /** 联系电话 */
    private String operatorPhone;

    /** 银行流水号 */
    private String serialNumber;

    /** 通知书路径 */
    private String noticePdfUrl;

    /** 监管协议路径 */
    private String agreementPdfUrl;

    /** 业务状态 0已撤销 1待开户 2开户完成*/
    private Integer businessState;

    /** 开户日期 */
    private Date openDate;

    /** 删除标识 1正常 0删除 */
    private Integer delFlag;

    /** 申请时间 */
    private Date createTime;

    /** 审批时间 */
    private Date updateTime;

    public SuperviseBusiness(){}

    public SuperviseBusiness(Account account, Org org, Project project, Jgyw jgyw){
        this.businessNumber = jgyw.getYwbh();
        if(null != account){
            this.bankCode = account.getBankCode();
            this.accountId = account.getId();
            this.bankName = account.getBankName();
            this.name = account.getName();
            this.account = account.getAccount();
            this.accountOpenAddress = account.getOpenAddress();
        }
        this.orgId = org.getId();
        this.orgName = org.getOrgName();
        this.projectId = project.getId();
        this.projectNumber = project.getProjectNumber();
        this.projectName = project.getProjectName();
        this.projectAddress = project.getProjectAddress();
        this.operator = jgyw.getLxr();
        this.operatorPhone = jgyw.getLxdh();
        this.businessState = 2;
        this.openDate = DateUtil.strToDate(jgyw.getSpsj(),"yyyy-MM-dd HH:mm:ss");
        this.delFlag = 1;
        this.createTime = DateUtil.strToDate(jgyw.getSqsj(),"yyyy-MM-dd HH:mm:ss");
        this.updateTime = DateUtil.strToDate(jgyw.getSpsj(),"yyyy-MM-dd HH:mm:ss");
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getBusinessNumber() {
        return businessNumber;
    }

    public void setBusinessNumber(String businessNumber) {
        this.businessNumber = businessNumber;
    }

    public String getBankCode() {
        return bankCode;
    }

    public void setBankCode(String bankCode) {
        this.bankCode = bankCode;
    }

    public Integer getOrgId() {
        return orgId;
    }

    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public String getProjectNumber() {
        return projectNumber;
    }

    public void setProjectNumber(String projectNumber) {
        this.projectNumber = projectNumber;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getProjectAddress() {
        return projectAddress;
    }

    public void setProjectAddress(String projectAddress) {
        this.projectAddress = projectAddress;
    }

    public Long getAccountId() {
        return accountId;
    }

    public void setAccountId(Long accountId) {
        this.accountId = accountId;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getAccountOpenAddress() {
        return accountOpenAddress;
    }

    public void setAccountOpenAddress(String accountOpenAddress) {
        this.accountOpenAddress = accountOpenAddress;
    }

    public String getOperator() {
        return operator;
    }

    public void setOperator(String operator) {
        this.operator = operator;
    }

    public String getOperatorPhone() {
        return operatorPhone;
    }

    public void setOperatorPhone(String operatorPhone) {
        this.operatorPhone = operatorPhone;
    }

    public String getSerialNumber() {
        return serialNumber;
    }

    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public String getNoticePdfUrl() {
        return noticePdfUrl;
    }

    public void setNoticePdfUrl(String noticePdfUrl) {
        this.noticePdfUrl = noticePdfUrl;
    }

    public String getAgreementPdfUrl() {
        return agreementPdfUrl;
    }

    public void setAgreementPdfUrl(String agreementPdfUrl) {
        this.agreementPdfUrl = agreementPdfUrl;
    }

    public Integer getBusinessState() {
        return businessState;
    }

    public void setBusinessState(Integer businessState) {
        this.businessState = businessState;
    }

    public Date getOpenDate() {
        return openDate;
    }

    public void setOpenDate(Date openDate) {
        this.openDate = openDate;
    }

    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }
}
