package com.cool.bang.modules.mysql.mapper;

import com.cool.bang.modules.mysql.domain.Account;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalFlow;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalNode;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalRecord;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 审批流通用DAO
 */
@Repository
public interface FlowMapper {

    /**
     * 根据流程类型查询流程
     *
     */
    ApprovalFlow selectFlowByType(Integer type);

    /**
     * 根据流程号查询节点
     * @param flowNumber
     * @return
     */
    List<ApprovalNode> selectNodeByFlowNumber(String flowNumber);

    /**
     * 插入审批流程记录
     * @param approvalRecord
     * @return
     */
    int insertRecord(ApprovalRecord approvalRecord);

    /**
     * 批量插入审批流程记录
     * @param approvalRecordList
     * @return
     */
    int insertRecordBatch(@Param("list") List<ApprovalRecord> approvalRecordList);
}
