package com.cool.bang.modules.mysql.service;

import com.cool.bang.common.util.DateUtil;
import com.cool.bang.modules.mysql.domain.*;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalFlow;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalNode;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalRecord;
import com.cool.bang.modules.mysql.mapper.*;
import com.cool.bang.modules.oracle.domain.*;
import com.cool.bang.modules.oracle.domain.po.*;
import com.cool.bang.modules.oracle.mapper.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@Service
public class MySQLSecondService {

    @Autowired
    private MySqlMapper mySqlMapper;
    @Autowired
    private OracleMapper oracleMapper;
    @Autowired
    private OrgMapper qyxxMapper;
    @Autowired
    private AccountMapper accountMapper;
    @Autowired
    private FlowMapper flowMapper;
    @Autowired
    private ApplyMapper applyMapper;
    @Autowired
    private FWMapper fwMapper;
    @Autowired
    private ProjectAccountMapper projectAccountMapper;
    @Autowired
    private BuildingAccountMapper buildingAccountMapper;
    @Autowired
    private ProjectMapper projectMapper;


    /**
     * 退款
     */
    @Transactional
    public void refundTo() {
//        System.out.println("===============fc_refund 导入数据开始=================");
//        // 获取结束节点
//        ApprovalFlow approvalFlow = flowMapper.selectFlowByType(6); //合同退款
//        ApprovalNode endNode = new ApprovalNode();
//        List<ApprovalNode> approvalNodeList = flowMapper.selectNodeByFlowNumber(approvalFlow.getFlowNumber());
//        for (ApprovalNode node : approvalNodeList) {
//            if (node.getNumber() == 4) {
//                endNode = node;
//            }
//        }
        List<TkInfo> htTkList = oracleMapper.selectHtTk();
//        for (TkInfo item : htTkList) {
//            Integer qybh = StringUtils.isEmpty(item.getQybh()) ? null : Integer.valueOf(item.getQybh());
//            Org org = qyxxMapper.selectOrgByMisid(qybh);
//
//            BuildingAccount buildingAccount = null;
//            if (!StringUtils.isEmpty(item.getLzbh())) {
//                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
//            }
//            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
//            ProjectAccount projectAccount = null;
//            if (null != projectAccountId) {
//                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
//            }
//            Account account = null;
//            if (!StringUtils.isEmpty(item.getAccountNo())) {
//                account = accountMapper.selectByAccountNO(item.getAccountNo());
//            }
//            ContractInfo contract = null;
//            if (!StringUtils.isEmpty(item.getHtBh())) {
//                contract = mySqlMapper.getInfoByNumber(item.getHtBh());
//            }
//            Refund refund = new Refund(item, org, projectAccount, account, contract, buildingAccount);
//            //定金退款的
//            if (null == item.getMoney()) {
//                refund.setAppropriationStatus("0");
//            } else {
//                refund.setAppropriationStatus("1");
//            }
//            // 如果是流程结束
//            if (item.getFLOWSTATE().equals("0")) {
//                refund.setBusinessState(3);
//            }
//            if (item.getFLOWSTATE().equals("1")) {
//                refund.setBusinessState(2);
//            }
//            refund.setFlowNumber(approvalFlow.getFlowNumber());
//            refund.setFlowNodeId(endNode.getId());
//            refund.setFlowNodeName(endNode.getNodeName());
//            if (!StringUtils.isEmpty(item.getFWBH())) {
//                P_lpb_fw fw = fwMapper.getFwByMissid(item.getFWBH(), null);
//                if (null != fw) {
//                    refund.setHouseAddress(fw.getXxdz());
//                }
//            }
//            mySqlMapper.insertRefund(refund);
//
//            // 插入审批记录
//            List<ApprovalRecord> records = new ArrayList<>();
//            List<OracleApprovalRecord> oracleApprovalRecords =
//                    applyMapper.selectApprovalRecords_8(item.getAPPID());
//            if (oracleApprovalRecords != null && oracleApprovalRecords.size() > 0
//                    && oracleApprovalRecords.get(0) != null
//                    && !StringUtils.isEmpty(oracleApprovalRecords.get(0).getNodeName())) {
//                for (OracleApprovalRecord oracleApprovalRecord : oracleApprovalRecords) {
//                    ApprovalRecord record = new ApprovalRecord();
//                    record.setBusinessNumber(item.getBusinessNumber());
//                    record.setFlowNumber(approvalFlow.getFlowNumber());
//                    record.setNodeId(endNode.getId());
//                    if (!StringUtils.isEmpty(oracleApprovalRecord.getNodeName())) {
//                        record.setNodeName(oracleApprovalRecord.getNodeName());
//                    }
//                    record.setApprover(oracleApprovalRecord.getApprover());
//                    record.setApprovalTime(oracleApprovalRecord.getApprovalTime());
//                    record.setTableId(refund.getId());
//                    if (oracleApprovalRecord.getApprovalStatus() != null) {
//                        record.setApprovalStatus(1);
//                    }
//                    record.setApprovalRemark(oracleApprovalRecord.getRemark());
//                    records.add(record);
//                }
//                flowMapper.insertRecordBatch(records);
//            }
//        }
        System.out.println("===============fc_refund数据匹配结束=================");
    }


    @Transactional
    public void tradeDDZTo() {
        System.out.println("===============fc_trade 导入数据开始=================");
        List<TradeInfo> tradeInfoList = oracleMapper.selectDDZ();
        List<FcTrade> fcTrades = new ArrayList<>();

        for (TradeInfo item : tradeInfoList) {
            BuildingAccount buildingAccount = null;
            if (!StringUtils.isEmpty(item.getLzbh())) {
                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
            }
            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
            ProjectAccount projectAccount = null;
            if (null != projectAccountId) {
                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
            }
            Account account = null;
            if (!StringUtils.isEmpty(item.getAccountNo())) {
                account = accountMapper.selectByAccountNO(item.getAccountNo());
            }

            FcTrade fcTrade = new FcTrade(item, projectAccount, account, buildingAccount);

            fcTrades.add(fcTrade);
        }
        mySqlMapper.insertFcTrade(fcTrades);
        System.out.println("===============fc_trade数据匹配结束=================");
    }

    @Transactional
    public void tradeTgTo() {
        System.out.println("===============fc_trade 导入数据开始=================");
        List<TradeInfo> tradeInfoList = oracleMapper.selectTG();

        List<FcTrade> fcTrades = new ArrayList<>();

        for (TradeInfo item : tradeInfoList) {
            BuildingAccount buildingAccount = null;
            if (!StringUtils.isEmpty(item.getLzbh())) {
                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
            }
            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
            ProjectAccount projectAccount = null;
            if (null != projectAccountId) {
                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
            }
            Account account = null;

            if (!StringUtils.isEmpty(item.getAccountNo())) {
                account = accountMapper.selectByAccountNO(item.getAccountNo());
            }

            FcTrade fcTrade = new FcTrade(item, projectAccount, account, buildingAccount);
            if (2 == fcTrade.getType()) {//支出的 projectAccountId
                Long pAId = mySqlMapper.getProjectAccountIdByAregId(item.getAregId());
                fcTrade.setProjectAccountId(pAId);
            }
            fcTrades.add(fcTrade);
        }
        mySqlMapper.insertFcTrade(fcTrades);
        System.out.println("===============fc_trade数据匹配结束=================");
    }

    /**
     * 对账
     */
    public void accountChecking() {
        List<Map<String, Object>> tgXm = mySqlMapper.selectTgXm();
        List<String> list = new ArrayList<>();
        list.add("项目名称;项目编号;楼幢名称;楼幢编号;监管资金转托管;交存资金;拨付资金;计算余额;账户余额;是否一致;余额差值");
        for (Map<String, Object> map : tgXm) {
            List<Map<String, Object>> xmAccount = mySqlMapper.selectXmAccountByProjectId((Long) map.get("id"));
            for (Map<String, Object> account : xmAccount) {
                List<Map<String, Object>> buildingInfo = mySqlMapper.selectBuildingBy((Long) map.get("id"), (Long) account.get("id"));
                for (Map<String, Object> building : buildingInfo) {
                    //监管转托管
                    BigDecimal zgToTg = oracleMapper.sumByZgToTg((String) (building.get("building_number")));
                    zgToTg = null == zgToTg ? BigDecimal.ZERO : zgToTg;
                    //交存
                    BigDecimal jc = oracleMapper.sumByJc((String) building.get("building_number"));
                    jc = null == jc ? BigDecimal.ZERO : jc;
                    //拨付
                    BigDecimal bf = oracleMapper.sumByBf((String) building.get("building_number"));
                    bf = null == bf ? BigDecimal.ZERO : bf;

                    BigDecimal accountBalance = mySqlMapper.getAccountBalanceByNumber((String) building.get("building_number"));
                    accountBalance = accountBalance == null ? BigDecimal.ZERO : accountBalance;
                    BigDecimal hj = (zgToTg.add(jc)).subtract(bf);
                    StringBuilder str = new StringBuilder();
                    String buildingName = String.valueOf(building.get("building_name"));
                    BigDecimal cz = BigDecimal.ZERO;
                    if (!(hj.compareTo(accountBalance) == 0)) {
                        cz = hj.subtract(accountBalance);
                    }
                    str.append(building.get("project_name").toString())
                            .append(";" + building.get("project_number").toString())
                            .append(";" + buildingName)
                            .append(";" + building.get("building_number").toString())
                            .append(";" + zgToTg)
                            .append(";" + jc)
                            .append(";" + bf)
                            .append(";" + hj)
                            .append(";" + accountBalance)
                            .append(";" + (hj.compareTo(accountBalance) == 0 ? "是" : "否"))
                            .append(";" + (hj.compareTo(accountBalance) == 0 ? "0" : cz));
                    // System.out.println(str.toString());
                    list.add(str.toString());
                }
            }
        }
        for (String str : list) {
            System.out.println(str);
        }
    }

    /**
     * 银行账户对账
     */
    public void bankAccountChecing() {
        List<Account> list = mySqlMapper.selectTgAccountInfo();
        List<Account> wdzJc = oracleMapper.getWdzJc();
        List<Account> wdzBf = oracleMapper.getWdzBf();
        List<String> strs = new ArrayList<>();
        strs.add("银行名称;银行编号;已计算余额;系统未对账的交存;系统未对账的拨付;其他金额;账户余额;差值");
        //处理特殊的对账
        //1、寿光农商银行  缺失的 定金626475.6 (银行流水号 = 041002202216625184199811) 手续费0.44（银行流水号= 041002202216655621675571） (总的楼栋户的合计 比 账户余额少 这两笔 需要加上这两笔 )
        //2、中国建设银行股份有限公司寿光支行 bankCode：02   手续费 -200(银行流水号= 021002202216625378315471) （总的楼栋户的合计 比对完账的账户余额 多200 总的楼栋户合计需要加上这个-200）
        //3、中国邮政储蓄银行股份有限公司寿光市支行 利息186893.99 (银行流水号=161002202316730870521161) （总的楼栋户的合计 比账户余额少这一笔  总的楼栋户合计需要加上这个 186893.99）
        List<String> serialNumbers = new ArrayList<>();
        serialNumbers.add("041002202216625184199811");
        serialNumbers.add("041002202216655621675571");
        serialNumbers.add("021002202216625378315471");
        serialNumbers.add("161002202316730870521161");
        List<Account> tsList = mySqlMapper.selectTsDzByserial(serialNumbers);
        for (Account account : list) {

            //未对账的交存
            BigDecimal jc = BigDecimal.ZERO;
            if (wdzJc != null && !wdzJc.isEmpty()) {
                Account jcAccount = wdzJc.stream().filter(t -> !StringUtils.isEmpty(t.getBankCode()) && t.getBankCode().equals(account.getBankCode())).findFirst().orElse(null);
                jc = null != jcAccount ? jcAccount.getBalance() : BigDecimal.ZERO;
            }
            //未对账的拨付
            BigDecimal bf = BigDecimal.ZERO;
            if (wdzBf != null && !wdzBf.isEmpty()) {
                Account bfAccount = wdzBf.stream().filter(t -> !StringUtils.isEmpty(t.getBankCode()) && t.getBankCode().equals(account.getBankCode())).findFirst().orElse(null);
                bf = null != bfAccount ? bfAccount.getBalance() : BigDecimal.ZERO;
            }
            //当前托管户 的其他类型的 对账金额
            BigDecimal otherTypeAmount = BigDecimal.ZERO;
            Account otherTypeAccount = tsList.stream().filter(t -> !StringUtils.isEmpty(t.getBankCode()) && t.getBankCode().equals(account.getBankCode())).findFirst().orElse(null);
            if (otherTypeAccount != null) {
                otherTypeAmount = otherTypeAccount.getBalance();
                otherTypeAmount = null != otherTypeAmount ? otherTypeAccount.getBalance() : BigDecimal.ZERO;
            }

            StringBuilder str = new StringBuilder();
            str.append(account.getBankName())
                    .append(";" + account.getBankCode())
                    .append(";" + account.getBalance())
                    .append(";" + jc)
                    .append(";" + bf)
                    .append(";" + otherTypeAmount)
                    .append(";" + account.getAccountBalance())
                    .append(";" + ((account.getBalance().subtract(jc)).add(bf).add(otherTypeAmount)).subtract(account.getAccountBalance()));
            strs.add(str.toString());
        }

        for (String str : strs) {
            System.out.println(str);
        }
    }

    public void contractFundCheckTrade() {
        List<FundInfo> tgFund = mySqlMapper.getTgFund();
        List<String> strs = new ArrayList<>();
        for (FundInfo item : tgFund) {
            //查询 交易
            BigDecimal amount = mySqlMapper.getAmountByBusinessNumber(item.getBusinessNumber());
            StringBuilder str = new StringBuilder();
            str.append(item.getContractNumber() + ";")
                    .append(item.getContractId() + ";")
                    .append(item.getBusinessNumber() + ";")
                    .append(1 == item.getPaymentStatus() ? "未足额" : (2 == item.getPaymentStatus() ? "已交存" : (0 == item.getPaymentStatus() ? "未交存" : "")))
                    .append(";" + item.getPayableAmount() + ";")
                    .append(amount + ";")
                    .append(item.getPayableAmount().compareTo(amount) == 0 ? "是" : "否");
            strs.add(str.toString());
        }
        System.out.flush();
        for (String str : strs) {
            System.out.println(str);
        }
    }

    @Transactional
    public void buildingRelieve() {
        List<OracleRelieve> oracleRelieves = applyMapper.selectLDRelieves();

        // 查询审批流程
        ApprovalFlow approvalFlow = flowMapper.selectFlowByType(7); // 解除楼栋申请flowId = 7
        List<ApprovalNode> nodes = flowMapper.selectNodeByFlowNumber(approvalFlow.getFlowNumber());
        ApprovalNode endNode = new ApprovalNode();
        for (ApprovalNode node : nodes) {
            if (node.getNumber() == 3) {
                endNode = node;
            }
        }

        for (OracleRelieve oracleRelieve : oracleRelieves) {

            // 审核不通过的，不导入
            if (oracleRelieve.getFlowState().equals(1) &&
                    oracleRelieve.getFlowNodeName().equals("解除楼幢初审不通过")) {
                continue;
            }

            Relieve relieve = new Relieve(oracleRelieve);

            // 申请未审核的导入
            if (oracleRelieve.getFlowState().equals(1) &&
                    oracleRelieve.getFlowNodeName().equals("解除楼幢申请上报")) {
                relieve.setBusinessState(1);
            } else if (oracleRelieve.getFlowState().equals(1) && oracleRelieve.getFlowNodeName().equals("保存")) {
                relieve.setBusinessState(0);
            } else if (oracleRelieve.getFlowState().equals(1) && oracleRelieve.getFlowNodeName().equals("解除楼幢初审通过")) {
                relieve.setBusinessState(2);
            } else if (oracleRelieve.getFlowState().equals(1)) {
                throw new RuntimeException("解除项目异常：" + oracleRelieve.getFlowNodeName());
            }

            // 审核已完成
            if (oracleRelieve.getFlowState().equals(0)) {
                relieve.setBusinessState(3);
            }

            Org org = qyxxMapper.selectOrgByMisid(oracleRelieve.getOrgMisId());
            relieve.setOrgId(org.getId());
            relieve.setOrgName(org.getOrgName());

            Project project = projectMapper.selectByProjectNumber(oracleRelieve.getProjectNumber());
            relieve.setProjectId(project.getId());
            relieve.setProjectNumber(project.getProjectNumber());
            relieve.setProjectName(project.getProjectName());

            relieve.setFlowNumber(approvalFlow.getFlowNumber());
            relieve.setFlowNodeId(endNode.getId());
            relieve.setFlowNodeName(endNode.getNodeName());

            // 楼栋解除
 /*           List<Areg> list = applyMapper.selectIsRelieve(relieve.getProjectNumber());
            if (list.size() == 1) {
                relieve.setRelieveType(1); // 项目解除
                // 如果是未审核通过的，改为解除中
                if (oracleRelieve.getFlowState().equals(1)) {
                    projectMapper.updateRelieve(relieve.getProjectId(), 2);
                } else {
                    projectMapper.updateRelieve(relieve.getProjectId(), 0);
                }
            } else {*/
            relieve.setRelieveType(2);
            /*}*/
            mySqlMapper.insertRelieve(relieve);

            // ------------------------------ 楼栋解除详情 ----------------------------------

            List<RelieveDetail> relieveDetails = new ArrayList<>();
            List<OracleRelieveDetail> oracleRelieveDetails = applyMapper.selectLDRelieveDetails(oracleRelieve.getAppId());
            if (oracleRelieveDetails != null && oracleRelieveDetails.size() > 0
                    && oracleRelieveDetails.get(0) != null && !StringUtils.isEmpty(oracleRelieveDetails.get(0).getBuildingNumber())) {
                StringBuilder relieveBuilding = new StringBuilder();
                for (OracleRelieveDetail detail : oracleRelieveDetails) {
                    BuildingAccount building = buildingAccountMapper.selectByBuildingNumber(detail.getBuildingNumber());
                    RelieveDetail relieveDetail = new RelieveDetail(building);
                    relieveDetail.setRelieveId(relieve.getId());
                    relieveDetails.add(relieveDetail);
                    relieveBuilding.append(building.getBuildingName()).append(",");
                }
                String buildingNames = relieveBuilding.toString().substring(0, relieveBuilding.length() - 1);
                mySqlMapper.updateRelieveBuilding(relieve.getId(), buildingNames);
                mySqlMapper.insertRelieveDetail(relieveDetails);
                buildingAccountMapper.updateRelieve(relieveDetails, relieve.getUpdateTime());
            }


            // ------------------------------ 楼栋解除审批记录 ----------------------------------

            List<ApprovalRecord> approvalRecords = new ArrayList<>();
            List<OracleApprovalRecord> oracleApprovalRecords = applyMapper.selecLDRelieveRecord(oracleRelieve.getAppId());
            if (oracleApprovalRecords != null && oracleApprovalRecords.size() > 0
                    && oracleApprovalRecords.get(0) != null
                    && !StringUtils.isEmpty(oracleApprovalRecords.get(0).getNodeName())) {
                for (OracleApprovalRecord approval : oracleApprovalRecords) {
                    ApprovalRecord record = new ApprovalRecord();
                    record.setBusinessNumber(relieve.getBusinessNumber());
                    record.setFlowNumber(relieve.getFlowNumber());
                    record.setTableId(relieve.getId());
                    record.setApprovalTime(approval.getApprovalTime());
                    record.setApprovalRemark(approval.getRemark());
                    record.setCreateTime(record.getApprovalTime());
                    record.setUpdateTime(record.getApprovalTime());
                    record.setDelFlag(1);
                    if (StringUtils.isEmpty(approval.getApprovalStatus())) {
                        record.setNodeName("申请节点");
                        record.setApprover(relieve.getOrgName() + "(" + approval.getApprover() + ")");
                    } else {
                        record.setNodeName(approval.getNodeName());
                        record.setApprover("监管部门(" + approval.getApprover() + ")");
                        if (approval.getApprovalStatus().equals("1")) {
                            record.setApprovalStatus(1);
                        } else {
                            record.setApprovalStatus(2);
                        }
                    }
                    approvalRecords.add(record);
                }
                flowMapper.insertRecordBatch(approvalRecords);
            }
        }
    }


}
